<!-----------------------------------------------------------------------
Author 	 :	Your Name
Date     :	September 25, 2005
Description : 			
	This is a ColdBox event handler.

Please note that the extends needs to point to the eventhandler.cfc
in the ColdBox system directory.
extends = coldbox.system.eventhandler
	
----------------------------------------------------------------------->
<cfcomponent name="ehGeneral" extends="coldbox.system.eventhandler">
	
<!------------------------------------------- CONSTRUCTOR ------------------------------------------->


<!------------------------------------------- PUBLIC ------------------------------------------->
	
	<cffunction name="onAppInit" access="public" returntype="void" output="false">
		<cfset var MyService = getSetting("AppMapping") & ".model.GeneratorService">
		<cfset application.GService = CreateObject("component","#MyService#").init(getSetting("adminpass"))>
	</cffunction>
		
	<cffunction name="onException" access="public" returntype="void" output="false">
		<!--- ON Exception Here --->
	</cffunction>
	
	<cffunction name="dspHome" access="public" returntype="void" output="false">
		<!--- EXIT HANDLERS: --->
		<cfset rc.xehProcessDSN = "ehGeneral.doProcessDSN">
		<cfset rc.DSNs = getDSNs() />
		<cfset setView("vwHome")>
	</cffunction>
	
	<cffunction name="doProcessDSN" access="public" returntype="void" output="false">
		<cfset var thisDSN = "" />
		<!--- EXIT HANDLERS: --->
		<cfset rc.xehGenerate = "ehGeneral.doGenerate">
		
		<!--- Get Setup --->
		<cfset rc.DSNs = getDSNs() />
		<cfset rc.dbType = getDBType()>
		<cfset rc.tables = getTables()>
		
		<!--- Param Values --->
		<cfset paramComponents()>
		
		<!--- Set View --->
		<cfset setView("vwComponents")>
		
	</cffunction>
	
	<cffunction name="doGenerate" access="public" returntype="void" output="false">
		<!--- EXIT HANDLERS: --->
		<cfset rc.xehGenerate = "ehGeneral.doGenerate">
		
		<!--- Get Setup --->
		<cfset rc.DSNs = getDSNs() />
		<cfset rc.dbType = getDBType()>
		<cfset rc.tables = getTables()>
		
		<!--- Get Table XML --->
		<cfset application.GService.getModel(rc.dbType).setTable(getValue("table")) />
		<cfset application.GService.getModel(rc.dbType).setComponentPath(getValue("componentPath")) />
		<cfset rc.xmlTable = application.GService.getModel(rc.dbType).getTableXML() />
		
		<!--- Get Generated CFC's --->
		<cfset application.GService.getModel("xsl").configure(getValue("dsn")) />
		<!--- get an array containing the generated code --->
		<cfset rc.arrComponents = application.GService.getModel("xsl").getComponents(rc.xmlTable) />
		
		<!--- Set the View --->
		<cfset setView("vwGeneration")>
	</cffunction>
	
	
<!------------------------------------------- PRIVATE ------------------------------------------->

	<cffunction name="getDSNs" access="public" returntype="struct" output="false">
		<cfreturn application.GService.getModel("adminAPIService").getdatasources() />
	</cffunction>
	
	<cffunction name="getDBType" access="public" returntype="string" output="false">
		<cfset var thisDSN = rc.DSNs[getvalue("dsn")] />
		<cfif thisDSN.driver eq "MSSQLServer"  or thisDSN.class contains "MSSQLServer">
			<cfreturn "mssql" />
		<cfelseif thisDSN.driver contains "mySQL" or thisDSN.class contains "mySQL">
			<cfreturn "mysql" />
		<cfelseif thisDSN.driver contains "Oracle" or thisDSN.class contains "Oracle">
			<cfreturn "Oracle" />
		</cfif>		
	</cffunction>
	
	<cffunction name="getTables" access="public" returntype="query" output="false">
		<cfset application.GService.getModel(rc.dbType).setDSN(rc.dsn)>
		<cfreturn application.GService.getModel(rc.dbType).getTables() />
	</cffunction>
	
	<cffunction name="paramComponents" access="public" returntype="void" output="false">
		<cfset paramValue("table", "")>
		<cfset paramValue("componentPath", "")>
		<cfset paramValue("generateService", "0")>
		<cfset paramValue("generateTO", "0")>
		<cfset paramValue("generateColdspringXML", "0")>
	</cffunction>
	
	
</cfcomponent>