<!-----------------------------------------------------------------------
Author 	 :	Your Name
Date     :	September 25, 2005
Description : 			
	This is a ColdBox event handler.

Please note that the extends needs to point to the eventhandler.cfc
in the ColdBox system directory.
extends = coldbox.system.eventhandler
	
----------------------------------------------------------------------->
<cfcomponent name="ehGeneral" extends="coldbox.system.eventhandler">
	
	<cffunction name="onAppStart" access="public" returntype="void" output="false">
		<!--- ON Application Start Here --->
		<cfset application.i18nUtils = getPlugin("i18n").setfwLocale(getSetting("DefaultLocale"))>
	</cffunction>
	
	<cffunction name="onRequestStart" access="public" returntype="void" output="false">
		<!--- On Request Start Code Here --->
	</cffunction>
	
	<cffunction name="dspHome" access="public" returntype="void" output="false">
		<cfscript>
		//Vars
		var hours = randRange(20,200);
		
		// Param Values
		paramValue("thisLocale", "th_TH");
		paramValue("dateF", "0");
		paramValue("timeF", "2");
		
		//Change Locale
		application.i18nUtils.setfwLocale(rc.thisLocale);
				
		//Set variables to display for locale.
		rc.now = application.i18nUtils.toEpoch(now());
		rc.locales = application.i18nUtils.getLocales();
		rc.lang = application.i18nUtils.showLanguage();
		rc.country = application.i18nUtils.showCountry();
		//rc.c = application.i18nUtils.showISOCountry();
		rc.timeZones = application.i18nUtils.getAvailableTZ();
		rc.serverTZ = application.i18nUtils.getServerTZ();
		rc.thisTZ = rc.timezones[randRange(1,arrayLen(rc.timeZones))];
		rc.laterOn = application.i18nUtils.i18nDateAdd(rc.now,"hour",hours,rc.thisTZ);
		rc.usesDST = application.i18nUtils.usesDST(rc.thisTZ);
		if (rc.usesDST)
			rc.inDST=application.i18nUtils.inDST(rc.now,rc.thisTZ);
		rc.tDate=application.i18nUtils.i18nDateFormat(rc.now,rc.dateF,rc.thisTZ);
		rc.tDateTime=application.i18nUtils.i18nDateTimeFormat(rc.now,rc.dateF,rc.timeF,rc.thisTZ);
		rc.version=application.i18nUtils.getVersion();
		rc.tzOffset=application.i18nUtils.getTZOffset(rc.now,rc.thisTZ);
       
       //Set the view
       setView("vwHome");
		</cfscript>
	</cffunction>
	
</cfcomponent>