<!-----------------------------------------------------------------------
Author 	 :	Your Name
Date     :	September 25, 2005
Description :

	coldboxSamples.system.eventhandler

----------------------------------------------------------------------->
<cfcomponent name="ehGeneral" extends="coldbox.system.eventhandler">

	<!--- ************************************************************* --->
	<cffunction name="onRequestStart" access="public" returntype="void" output="false">
	<!---
	Security Check
	You need to check for the doLogin method, beacuse, if not, the doLogin method
	will never get a chance to be called.
	So check if the session.loggedin flag exists or not true, and if we
	are not logging in.
	--->
	<cfscript>
		//Set xeh's
		rc.xehLogout = "ehGeneral.doLogout";
		rc.xehHome = "ehGeneral.dspHome";
		//Login Check
		if ( (not isDefined("session.loggedin") or not session.loggedin) and not rc.event eq "ehGeneral.doLogin" )
			overrideEvent("ehGeneral.dspLogin");		
	</cfscript>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="dspLogin" access="public" returntype="void" output="false">
	<cfscript>
		//Set xeh's
		rc.xehLogin = "ehGeneral.doLogin";
		//Set the page's title
		setValue("title", "ColdBox - Sample Login App: Login page");
		//Set the view to display
		setView("vwLogin");
	</cfscript>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="doLogin" access="public" returntype="void" output="false">
	<cfscript>
		//Do Login Procedure.
		var objDataStore = "";
		var ValidationStruct = "";
		//Error checks, does the form variables username & password exist
		//in the request collection? if they do, are they blank?
		if( not valueExists("username") or not valueExists("password") ){
			//Set a message to display
			getPlugin("messagebox").setMessage("error","No username or password defined.");
			getPlugin("logger").logEntry("error","Login without variables set detected.");
			//Redirect to next event, you can also add extra parameters to the URL
			setNextEvent("ehGeneral.dspLogin","username=#getValue("username","")#");
		}
		else{
			//Init DataStorage
			objDataStore = CreateObject("component","#getSetting("AppMapping")#.model.datastore").init();
			ValidationStruct = objDataStore.validateUser(rc.username, rc.password);
			if ( ValidationStruct.validated ){
				//Login Correct.
				//set my session var
				session.loggedin = true;
				session.name = ValidationStruct.qUser.name;
				getPlugin("logger").logEntry("information","The user #validationStruct.qUser.name# has now logged in.");
				setNextEvent("ehGeneral.dspHome");
			}
			else{
				//Set a message to display
				getPlugin("messagebox").setMessage("error","Invalid Logon Information. Please try again");
				getPlugin("logger").logEntry("warning","Invalid logon information detected. IP used: #cgi.remote_addr#");
				//Redirect to next event, you can also add extra parameters to the URL
				setNextEvent("ehGeneral.dspLogin","username=#getValue("username")#");
			}	
		}
	</cfscript>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="dspHome" access="public" returntype="void" output="false">
	<cfscript>
		//Set the page's title
		setValue("title", "Sample Login App: Welcome Back");
		//Set the view to display
		setView("vwHome");
	</cfscript>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="doLogout" access="public" returntype="void" output="false">
	<cfscript>
		//Log it
		getPlugin("logger").logEntry("information","User: #session.name# logged out successfully.");
		//Delete login INformation
		structdelete(session, "loggedin");
		structdelete(session, "name");
		//Set the next event to display
		setNextEvent("ehGeneral.dspLogin");
	</cfscript>
	</cffunction>
	<!--- ************************************************************* --->
</cfcomponent>